/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         WEBIDL_STYPE
#define YYLTYPE         WEBIDL_LTYPE
/* Substitute the variable and function names.  */
#define yyparse         webidl_parse
#define yylex           webidl_lex
#define yyerror         webidl_error
#define yydebug         webidl_debug
#define yynerrs         webidl_nerrs


/* Copy the first part of user declarations.  */
#line 1 "src/webidl-parser.y" /* yacc.c:339  */


/* This is a bison parser for Web IDL
 *
 * This file is part of nsgenbind.
 * Licensed under the MIT License,
 *                http://www.opensource.org/licenses/mit-license.php
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 *
 * Derived from the the grammar in apendix A of W3C WEB IDL
 *   http://www.w3.org/TR/WebIDL/
 */

#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include <stdint.h>
#include <math.h>

#include "webidl-ast.h"

#include "webidl-parser.h"
#include "webidl-lexer.h"

char *errtxt;

static void
webidl_error(YYLTYPE *locp, struct webidl_node **winbind_ast, const char *str)
{
  locp = locp;
  winbind_ast = winbind_ast;
    errtxt = strdup(str);
}


#line 110 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "webidl-parser.h".  */
#ifndef YY_WEBIDL_BUILD_LINUX_LINUX_RELEASE_BINARY_WEBIDL_PARSER_H_INCLUDED
# define YY_WEBIDL_BUILD_LINUX_LINUX_RELEASE_BINARY_WEBIDL_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef WEBIDL_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define WEBIDL_DEBUG 1
#  else
#   define WEBIDL_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define WEBIDL_DEBUG 1
# endif /* ! defined YYDEBUG */
#endif  /* ! defined WEBIDL_DEBUG */
#if WEBIDL_DEBUG
extern int webidl_debug;
#endif

/* Token type.  */
#ifndef WEBIDL_TOKENTYPE
# define WEBIDL_TOKENTYPE
  enum webidl_tokentype
  {
    TOK_ANY = 258,
    TOK_ATTRIBUTE = 259,
    TOK_BOOLEAN = 260,
    TOK_BYTE = 261,
    TOK_CALLBACK = 262,
    TOK_LEGACYCALLER = 263,
    TOK_CONST = 264,
    TOK_CREATOR = 265,
    TOK_DATE = 266,
    TOK_DELETER = 267,
    TOK_DICTIONARY = 268,
    TOK_DOUBLE = 269,
    TOK_ELLIPSIS = 270,
    TOK_ENUM = 271,
    TOK_EOL = 272,
    TOK_EXCEPTION = 273,
    TOK_FALSE = 274,
    TOK_FLOAT = 275,
    TOK_GETRAISES = 276,
    TOK_GETTER = 277,
    TOK_IMPLEMENTS = 278,
    TOK_IN = 279,
    TOK_INFINITY = 280,
    TOK_INHERIT = 281,
    TOK_INTERFACE = 282,
    TOK_LONG = 283,
    TOK_MODULE = 284,
    TOK_NAN = 285,
    TOK_NATIVE = 286,
    TOK_NULL_LITERAL = 287,
    TOK_OBJECT = 288,
    TOK_OCTET = 289,
    TOK_OMITTABLE = 290,
    TOK_OPTIONAL = 291,
    TOK_OR = 292,
    TOK_PARTIAL = 293,
    TOK_RAISES = 294,
    TOK_READONLY = 295,
    TOK_SETRAISES = 296,
    TOK_SETTER = 297,
    TOK_SEQUENCE = 298,
    TOK_SHORT = 299,
    TOK_STATIC = 300,
    TOK_STRING = 301,
    TOK_STRINGIFIER = 302,
    TOK_TRUE = 303,
    TOK_TYPEDEF = 304,
    TOK_UNRESTRICTED = 305,
    TOK_UNSIGNED = 306,
    TOK_VOID = 307,
    TOK_POUND_SIGN = 308,
    TOK_IDENTIFIER = 309,
    TOK_INT_LITERAL = 310,
    TOK_FLOAT_LITERAL = 311,
    TOK_STRING_LITERAL = 312,
    TOK_OTHER_LITERAL = 313,
    TOK_JAVADOC = 314
  };
#endif

/* Value type.  */
#if ! defined WEBIDL_STYPE && ! defined WEBIDL_STYPE_IS_DECLARED
typedef union WEBIDL_STYPE WEBIDL_STYPE;
union WEBIDL_STYPE
{
#line 46 "src/webidl-parser.y" /* yacc.c:355  */

    int attr;
    long value;
    bool isit;
    char* text;
    struct webidl_node *node;

#line 226 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:355  */
};
# define WEBIDL_STYPE_IS_TRIVIAL 1
# define WEBIDL_STYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined WEBIDL_LTYPE && ! defined WEBIDL_LTYPE_IS_DECLARED
typedef struct WEBIDL_LTYPE WEBIDL_LTYPE;
struct WEBIDL_LTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define WEBIDL_LTYPE_IS_DECLARED 1
# define WEBIDL_LTYPE_IS_TRIVIAL 1
#endif



int webidl_parse (struct webidl_node **webidl_ast);

#endif /* !YY_WEBIDL_BUILD_LINUX_LINUX_RELEASE_BINARY_WEBIDL_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 254 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined WEBIDL_LTYPE_IS_TRIVIAL && WEBIDL_LTYPE_IS_TRIVIAL \
             && defined WEBIDL_STYPE_IS_TRIVIAL && WEBIDL_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   660

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  75
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  74
/* YYNRULES -- Number of rules.  */
#define YYNRULES  208
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  336

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   314

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      66,    67,     2,     2,    65,    68,    71,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    64,    62,
      72,    63,    73,    74,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    69,     2,    70,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    60,     2,    61,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59
};

#if WEBIDL_DEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   195,   195,   199,   205,   215,   217,   219,   221,   223,
     225,   227,   233,   238,   243,   245,   250,   285,   293,   295,
     300,   332,   336,   394,   396,   401,   408,   411,   416,   421,
     427,   430,   436,   438,   443,   450,   453,   459,   463,   471,
     479,   483,   486,   491,   499,   507,   539,   557,   559,   561,
     566,   574,   579,   587,   595,   603,   611,   622,   627,   629,
     634,   636,   642,   650,   672,   676,   685,   689,   697,   706,
     708,   712,   715,   720,   722,   724,   726,   728,   733,   750,
     754,   766,   770,   779,   783,   792,   800,   808,   820,   822,
     828,   832,   840,   842,   847,   853,   857,   866,   870,   880,
     885,   891,   897,   907,   911,   920,   924,   933,   943,   953,
     962,   969,   974,   979,   984,   989,   994,   999,  1004,  1009,
    1014,  1019,  1024,  1029,  1034,  1039,  1044,  1049,  1054,  1059,
    1064,  1069,  1074,  1079,  1084,  1089,  1094,  1099,  1104,  1109,
    1114,  1119,  1124,  1129,  1134,  1139,  1147,  1152,  1157,  1162,
    1167,  1172,  1177,  1182,  1187,  1192,  1197,  1202,  1207,  1212,
    1217,  1222,  1227,  1232,  1237,  1245,  1250,  1258,  1263,  1272,
    1274,  1282,  1290,  1292,  1294,  1298,  1301,  1306,  1311,  1316,
    1323,  1328,  1333,  1341,  1346,  1358,  1360,  1362,  1367,  1372,
    1380,  1387,  1392,  1397,  1405,  1412,  1417,  1422,  1435,  1439,
    1448,  1452,  1457,  1466,  1470,  1477,  1480,  1485,  1487
};
#endif

#if WEBIDL_DEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ANY", "TOK_ATTRIBUTE",
  "TOK_BOOLEAN", "TOK_BYTE", "TOK_CALLBACK", "TOK_LEGACYCALLER",
  "TOK_CONST", "TOK_CREATOR", "TOK_DATE", "TOK_DELETER", "TOK_DICTIONARY",
  "TOK_DOUBLE", "TOK_ELLIPSIS", "TOK_ENUM", "TOK_EOL", "TOK_EXCEPTION",
  "TOK_FALSE", "TOK_FLOAT", "TOK_GETRAISES", "TOK_GETTER",
  "TOK_IMPLEMENTS", "TOK_IN", "TOK_INFINITY", "TOK_INHERIT",
  "TOK_INTERFACE", "TOK_LONG", "TOK_MODULE", "TOK_NAN", "TOK_NATIVE",
  "TOK_NULL_LITERAL", "TOK_OBJECT", "TOK_OCTET", "TOK_OMITTABLE",
  "TOK_OPTIONAL", "TOK_OR", "TOK_PARTIAL", "TOK_RAISES", "TOK_READONLY",
  "TOK_SETRAISES", "TOK_SETTER", "TOK_SEQUENCE", "TOK_SHORT", "TOK_STATIC",
  "TOK_STRING", "TOK_STRINGIFIER", "TOK_TRUE", "TOK_TYPEDEF",
  "TOK_UNRESTRICTED", "TOK_UNSIGNED", "TOK_VOID", "TOK_POUND_SIGN",
  "TOK_IDENTIFIER", "TOK_INT_LITERAL", "TOK_FLOAT_LITERAL",
  "TOK_STRING_LITERAL", "TOK_OTHER_LITERAL", "TOK_JAVADOC", "'{'", "'}'",
  "';'", "'='", "':'", "','", "'('", "')'", "'-'", "'['", "']'", "'.'",
  "'<'", "'>'", "'?'", "$accept", "Definitions", "Definition",
  "CallbackOrInterface", "CallbackRestOrInterface", "Interface", "Partial",
  "PartialDefinition", "PartialInterface", "InterfaceMembers",
  "InterfaceMember", "Dictionary", "DictionaryMembers", "DictionaryMember",
  "PartialDictionary", "Default", "DefaultValue", "Exception",
  "ExceptionMembers", "Inheritance", "Enum", "EnumValueList", "EnumValues",
  "CallbackRest", "Typedef", "ImplementsStatement", "Const", "ConstValue",
  "BooleanLiteral", "FloatLiteral", "AttributeOrOperation",
  "StringifierAttributeOrOperation", "Attribute", "Inherit", "ReadOnly",
  "Operation", "Qualifiers", "Specials", "Special", "OperationRest",
  "OptionalIdentifier", "ArgumentList", "Arguments", "Argument",
  "OptionalOrRequiredArgument", "ArgumentName", "Ellipsis",
  "ExceptionMember", "ExceptionField", "ExtendedAttributeList",
  "ExtendedAttributes", "ExtendedAttribute", "ExtendedAttributeRest",
  "ExtendedAttributeInner", "Other", "ArgumentNameKeyword", "OtherOrComma",
  "Type", "SingleType", "UnionType", "UnionMemberType", "UnionMemberTypes",
  "NonAnyType", "ConstType", "PrimitiveType", "UnrestrictedFloatType",
  "FloatType", "UnsignedIntegerType", "IntegerType", "OptionalLong",
  "TypeSuffix", "TypeSuffixStartingWithArray", "Null", "ReturnType", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     123,   125,    59,    61,    58,    44,    40,    41,    45,    91,
      93,    46,    60,    62,    63
};
# endif

#define YYPACT_NINF -212

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-212)))

#define YYTABLE_NINF -82

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      22,  -212,    11,  -212,   309,   163,  -212,  -212,  -212,  -212,
    -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,
    -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,
    -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,
    -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,  -212,
    -212,  -212,   235,  -212,  -212,  -212,   235,  -212,   235,  -212,
    -212,  -212,  -212,   -41,   309,  -212,   -18,   -20,    28,    33,
      45,    19,    -7,    60,  -212,  -212,  -212,  -212,  -212,  -212,
    -212,  -212,  -212,   235,  -212,   235,   235,    42,  -212,   235,
      38,    36,   309,    46,  -212,  -212,    56,  -212,  -212,  -212,
      44,    61,    44,    44,    66,    69,  -212,  -212,  -212,   515,
      71,    68,    63,    64,   309,  -212,   309,   309,   -41,  -212,
     381,    77,    79,    83,    84,    85,    86,    88,    74,  -212,
    -212,   -11,  -212,  -212,   122,   -11,  -212,    81,  -212,   -11,
      17,    -1,   -11,   557,    97,  -212,   -11,  -212,   -11,  -212,
    -212,  -212,  -212,    94,   235,   235,   235,  -212,  -212,  -212,
    -212,  -212,  -212,    91,  -212,   -36,    95,   100,   -14,  -212,
     -36,  -212,    93,  -212,    98,    74,  -212,  -212,  -212,  -212,
     515,  -212,  -212,  -212,  -212,   105,   -11,   132,  -212,   115,
    -212,  -212,  -212,  -212,  -212,  -212,    25,   117,   515,   123,
    -212,   120,   124,   431,     6,   125,    20,   -11,   -11,  -212,
     111,   118,  -212,   557,  -212,   126,   127,   473,   136,   -36,
     135,    95,  -212,   138,   108,  -212,   -14,  -212,   149,   143,
     187,   144,   145,  -212,  -212,   134,   -11,   173,   152,    -7,
    -212,   515,  -212,   196,  -212,  -212,   153,  -212,  -212,   134,
     164,   134,  -212,   157,  -212,  -212,  -212,  -212,  -212,  -212,
    -212,  -212,   121,  -212,  -212,  -212,  -212,   180,  -212,   381,
    -212,     8,  -212,  -212,  -212,  -212,  -212,   557,   154,  -212,
     127,   606,  -212,   606,    -4,   160,  -212,   162,  -212,  -212,
    -212,  -212,  -212,  -212,   169,  -212,   222,  -212,  -212,   173,
    -212,  -212,  -212,   153,  -212,  -212,  -212,  -212,  -212,  -212,
    -212,  -212,  -212,  -212,   203,  -212,  -212,  -212,  -212,  -212,
      29,  -212,   165,   515,  -212,  -212,  -212,   168,    25,   179,
    -212,   185,   174,   194,  -212,  -212
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     4,    95,     1,     0,     0,   128,   146,   129,   130,
     147,   158,   148,   149,   124,   150,   151,   131,   117,   152,
     153,   132,   133,   154,   155,   126,   156,   157,   134,   127,
     135,   136,   137,   139,   138,   159,   160,   140,   141,   161,
     125,   162,   142,   163,   164,   143,   144,   112,   110,   111,
     113,   114,   105,   119,   121,   118,   105,   115,   105,   116,
     120,   122,   123,    97,   103,   145,     0,     0,     0,     0,
       0,     0,    95,     0,     3,     5,    13,     6,     7,     8,
       9,    10,    11,   105,   166,   105,   105,     0,   165,   105,
       0,     0,     0,     0,   104,   102,     0,    12,    15,    14,
      37,     0,    37,    37,     0,     0,    17,    18,    19,     0,
       0,     0,     0,     0,   103,   109,   103,   103,    97,    96,
       0,     0,     0,     0,     0,     0,     0,     0,   203,   187,
     188,   200,   193,   192,   198,   200,   189,     0,   196,   200,
       0,     0,   200,     0,     0,   167,   200,   169,   200,   186,
     191,   185,   195,     0,   105,   105,   105,   101,    99,   100,
      98,   208,   207,     0,    38,    95,    41,     0,    95,    21,
      95,    21,     0,   170,     0,   203,   182,   199,   197,   181,
       0,   178,   190,   194,   179,     0,   200,     0,   172,     0,
     168,   177,    45,   108,   106,   107,    95,     0,     0,     0,
      40,     0,     0,     0,    95,     0,    95,   200,   200,   202,
       0,     0,   173,     0,    44,     0,    83,     0,     0,    95,
       0,    41,    39,     0,     0,    92,    95,    93,     0,     0,
      71,     0,     0,   204,   201,   205,   200,   175,     0,    95,
      82,     0,    85,    90,    25,    27,    30,    42,    34,   205,
       0,   205,    36,     0,    16,    77,    75,    76,    73,    65,
      74,    69,    64,    22,    23,    24,    58,    66,    59,     0,
      70,    71,    29,    20,   206,   180,   174,     0,     0,    43,
      83,     0,    91,     0,     0,     0,   184,     0,   183,    94,
      62,    57,    60,    61,    79,    67,     0,    68,    72,   175,
     171,    84,    89,    30,    88,    87,    52,    55,    56,    50,
      51,    49,    53,    33,     0,    31,    32,    47,    48,    28,
       0,    80,     0,     0,   176,    86,    54,     0,    95,     0,
      46,     0,     0,     0,    63,    78
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -212,  -212,  -212,  -212,  -212,   193,  -212,  -212,  -212,    99,
    -212,  -212,  -163,  -212,  -212,   -68,  -212,  -212,    40,   -34,
    -212,  -212,    43,  -212,  -212,  -212,    58,   -46,  -212,  -212,
    -212,  -212,    13,  -212,  -212,  -212,  -212,     5,  -212,    27,
    -212,   -26,    14,    72,  -212,    47,  -212,  -212,  -212,    -2,
     192,     4,   -16,   -44,     1,  -195,  -212,  -108,  -212,  -140,
    -211,    34,  -139,  -212,   114,  -212,   200,  -212,   207,  -212,
    -129,   130,  -147,   224
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,    74,    75,    97,    76,    77,   106,   107,   204,
     263,    78,   197,   219,   108,   285,   315,    79,   202,   122,
      80,   167,   200,    99,    81,    82,   225,   316,   317,   318,
     265,   291,   266,   267,   296,   268,   269,   270,   271,   293,
     322,   215,   240,   216,   242,   303,   283,   226,   227,   198,
      93,    94,    95,    87,    88,    65,    89,   162,   145,   146,
     187,   278,   147,   250,   148,   149,   150,   151,   152,   178,
     176,   173,   275,   294
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       5,   144,   237,   186,   188,    64,   179,   205,    63,    70,
     181,     3,    90,   184,    91,   306,   255,   190,   256,   191,
     257,   307,    -2,     1,    92,   -26,   308,   134,   309,    -2,
     258,   132,   104,     4,   100,    -2,    96,   133,    -2,   111,
      -2,   112,   113,   138,   310,   115,   105,   -35,   306,    -2,
     260,   311,   312,   313,   307,     4,   245,   212,   174,   308,
      -2,   309,     4,   175,   314,    64,   299,   229,   124,   125,
     109,    -2,   210,   186,   188,     4,    -2,   310,   233,   234,
       4,   232,   101,   110,   311,   312,   304,   102,   304,     4,
     220,    -2,   -81,    64,     4,   228,   118,   314,   157,   103,
     158,   159,   286,   114,   288,   116,   117,   276,   121,   243,
     193,   194,   195,   129,   130,    64,   119,    64,    64,   120,
     126,   123,   132,   127,   128,   153,   129,   130,   133,   154,
     155,   164,   131,   281,   156,   132,   134,   186,   188,   165,
     166,   133,   136,   172,   168,   169,   170,   259,   171,   134,
     177,   189,   138,   180,   135,   136,   192,   196,   140,   141,
     199,   201,   249,   207,   137,   138,   203,   139,   208,   213,
      66,   140,   141,   161,   211,   142,    67,   214,   218,    68,
     221,    69,   222,   290,   235,   223,   231,   143,   236,   246,
      70,   -64,   239,   238,   217,   255,   224,   256,   244,   257,
     248,    71,   230,   253,   230,   254,   272,   273,   274,   258,
     277,   282,    72,   259,   279,   329,   284,    73,   287,   289,
     295,   300,   319,   321,   203,   320,   323,   -64,   326,   260,
     330,   328,   261,   332,   262,   325,   334,   217,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,   333,    20,    21,    22,   335,    23,    24,    98,
      25,    26,    27,    28,   247,    29,   252,    30,    31,    32,
     206,    33,    34,    35,   327,   292,   298,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,   264,    47,
      48,    49,    50,    51,   301,    83,   297,    53,    54,    55,
      84,    85,   331,    57,    86,   209,    59,    60,    61,    62,
     160,   280,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,   217,    20,    21,    22,
     305,    23,    24,   324,    25,    26,    27,    28,   251,    29,
     182,    30,    31,    32,   163,    33,    34,    35,   183,     0,
       0,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,     0,    47,    48,    49,    50,    51,     0,    52,
       0,    53,    54,    55,     0,    56,     0,    57,    58,     0,
      59,    60,    61,    62,   128,     0,   129,   130,     0,     0,
       0,     0,   131,     0,     0,   132,     0,     0,     0,     0,
       0,   133,     0,     0,     0,     0,     0,     0,     0,   134,
       0,     0,     0,     0,   135,   136,     0,     0,     0,     0,
       0,     0,     0,     0,   137,   138,     0,   139,     0,     0,
       0,   140,   141,   161,   128,   142,   129,   130,     0,     0,
     224,     0,   131,     0,     0,   132,     0,   143,     0,     0,
       0,   133,     0,     0,     0,     0,     0,     0,     0,   134,
       0,     0,     0,     0,   135,   136,     0,     0,     0,     0,
       0,     0,     0,     0,   137,   138,   128,   139,   129,   130,
       0,   140,   141,     0,   131,   142,     0,   132,     0,     0,
       0,     0,     0,   133,     0,     0,     0,   143,     0,     0,
       0,   134,     0,     0,     0,     0,   135,   136,     0,   241,
       0,     0,     0,     0,     0,     0,   137,   138,   128,   139,
     129,   130,     0,   140,   141,     0,   131,   142,     0,   132,
       0,     0,     0,     0,     0,   133,     0,     0,     0,   143,
       0,     0,     0,   134,     0,     0,     0,     0,   135,   136,
       0,     0,     0,     0,     0,     0,     0,     0,   137,   138,
     185,   139,   129,   130,     0,   140,   141,     0,   131,   142,
       0,   132,     0,     0,     0,     0,     0,   133,     0,     0,
       0,   143,     0,     0,     0,   134,     0,     0,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
     137,   138,     0,   139,     0,     0,     0,   140,   141,     0,
       7,   142,     0,    10,    11,    12,    13,     0,    15,    16,
       0,     0,    19,   143,    20,     0,     0,     0,    23,    24,
       0,     0,    26,    27,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,     0,     0,     0,    36,     0,
       0,    39,     0,    41,     0,    43,    44,     0,     0,     0,
     302
};

static const yytype_int16 yycheck[] =
{
       2,   109,   213,   143,   143,     4,   135,   170,     4,    27,
     139,     0,    56,   142,    58,    19,     8,   146,    10,   148,
      12,    25,     0,     1,    65,    61,    30,    28,    32,     7,
      22,    14,    13,    69,    54,    13,    54,    20,    16,    83,
      18,    85,    86,    44,    48,    89,    27,    61,    19,    27,
      42,    55,    56,    57,    25,    69,   219,   186,    69,    30,
      38,    32,    69,    74,    68,    64,   277,    61,   102,   103,
      72,    49,   180,   213,   213,    69,    54,    48,   207,   208,
      69,    61,    54,    23,    55,    56,   281,    54,   283,    69,
     198,    69,    67,    92,    69,   203,    92,    68,   114,    54,
     116,   117,   249,    61,   251,    67,    70,   236,    64,   217,
     154,   155,   156,     5,     6,   114,    70,   116,   117,    63,
      54,    60,    14,    54,     3,    54,     5,     6,    20,    61,
      67,    54,    11,   241,    70,    14,    28,   277,   277,    60,
      57,    20,    34,    69,    60,    60,    60,    26,    60,    28,
      28,    54,    44,    72,    33,    34,    62,    66,    50,    51,
      65,    61,    54,    70,    43,    44,   168,    46,    70,    37,
       7,    50,    51,    52,    69,    54,    13,    62,    61,    16,
      57,    18,    62,    62,    73,    61,    61,    66,    70,    54,
      27,     4,    65,    67,   196,     8,     9,    10,    62,    12,
      62,    38,   204,    54,   206,    62,    62,    62,    74,    22,
      37,    15,    49,    26,    62,   323,    63,    54,    54,    62,
      40,    67,    62,    54,   226,    63,     4,    40,    25,    42,
      62,    66,    45,    54,    47,   303,    62,   239,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    67,    18,    19,    20,    62,    22,    23,    66,
      25,    26,    27,    28,   221,    30,   226,    32,    33,    34,
     171,    36,    37,    38,   320,   262,   271,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,   230,    54,
      55,    56,    57,    58,   280,    60,   269,    62,    63,    64,
      65,    66,   328,    68,    69,   175,    71,    72,    73,    74,
     118,   239,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,   328,    18,    19,    20,
     283,    22,    23,   299,    25,    26,    27,    28,   224,    30,
     140,    32,    33,    34,   120,    36,    37,    38,   141,    -1,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    58,    -1,    60,
      -1,    62,    63,    64,    -1,    66,    -1,    68,    69,    -1,
      71,    72,    73,    74,     3,    -1,     5,     6,    -1,    -1,
      -1,    -1,    11,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    -1,    46,    -1,    -1,
      -1,    50,    51,    52,     3,    54,     5,     6,    -1,    -1,
       9,    -1,    11,    -1,    -1,    14,    -1,    66,    -1,    -1,
      -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,     3,    46,     5,     6,
      -1,    50,    51,    -1,    11,    54,    -1,    14,    -1,    -1,
      -1,    -1,    -1,    20,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    28,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,     3,    46,
       5,     6,    -1,    50,    51,    -1,    11,    54,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,
       3,    46,     5,     6,    -1,    50,    51,    -1,    11,    54,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,
      -1,    66,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,    -1,
       4,    54,    -1,     7,     8,     9,    10,    -1,    12,    13,
      -1,    -1,    16,    66,    18,    -1,    -1,    -1,    22,    23,
      -1,    -1,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,    42,    -1,
      -1,    45,    -1,    47,    -1,    49,    50,    -1,    -1,    -1,
      54
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    76,     0,    69,   124,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      18,    19,    20,    22,    23,    25,    26,    27,    28,    30,
      32,    33,    34,    36,    37,    38,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    54,    55,    56,
      57,    58,    60,    62,    63,    64,    66,    68,    69,    71,
      72,    73,    74,   126,   129,   130,     7,    13,    16,    18,
      27,    38,    49,    54,    77,    78,    80,    81,    86,    92,
      95,    99,   100,    60,    65,    66,    69,   128,   129,   131,
     128,   128,    65,   125,   126,   127,    54,    79,    80,    98,
      54,    54,    54,    54,    13,    27,    82,    83,    89,   124,
      23,   128,   128,   128,    61,   128,    67,    70,   126,    70,
      63,    64,    94,    60,    94,    94,    54,    54,     3,     5,
       6,    11,    14,    20,    28,    33,    34,    43,    44,    46,
      50,    51,    54,    66,   132,   133,   134,   137,   139,   140,
     141,   142,   143,    54,    61,    67,    70,   127,   127,   127,
     125,    52,   132,   148,    54,    60,    57,    96,    60,    60,
      60,    60,    69,   146,    69,    74,   145,    28,   144,   145,
      72,   145,   141,   143,   145,     3,   134,   135,   137,    54,
     145,   145,    62,   128,   128,   128,    66,    87,   124,    65,
      97,    61,    93,   124,    84,    87,    84,    70,    70,   146,
     132,    69,   145,    37,    62,   116,   118,   124,    61,    88,
     132,    57,    62,    61,     9,   101,   122,   123,   132,    61,
     124,    61,    61,   145,   145,    73,    70,   135,    67,    65,
     117,    36,   119,   132,    62,    87,    54,    97,    62,    54,
     138,   139,    93,    54,    62,     8,    10,    12,    22,    26,
      42,    45,    47,    85,   101,   105,   107,   108,   110,   111,
     112,   113,    62,    62,    74,   147,   145,    37,   136,    62,
     118,   132,    15,   121,    63,    90,   147,    54,   147,    62,
      62,   106,   107,   114,   148,    40,   109,   114,   112,   135,
      67,   117,    54,   120,   130,   120,    19,    25,    30,    32,
      48,    55,    56,    57,    68,    91,   102,   103,   104,    62,
      63,    54,   115,     4,   136,    90,    25,   102,    66,   132,
      62,   116,    54,    67,    62,    62
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    75,    76,    76,    76,    77,    77,    77,    77,    77,
      77,    77,    78,    78,    79,    79,    80,    81,    82,    82,
      83,    84,    84,    85,    85,    86,    87,    87,    88,    89,
      90,    90,    91,    91,    92,    93,    93,    94,    94,    95,
      96,    97,    97,    98,    99,   100,   101,   102,   102,   102,
     102,   103,   103,   104,   104,   104,   104,   105,   105,   105,
     106,   106,   106,   107,   108,   108,   109,   109,   110,   111,
     111,   112,   112,   113,   113,   113,   113,   113,   114,   115,
     115,   116,   116,   117,   117,   118,   119,   119,   120,   120,
     121,   121,   122,   122,   123,   124,   124,   125,   125,   126,
     126,   126,   126,   127,   127,   128,   128,   128,   128,   128,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   131,   131,   132,   132,   133,
     133,   134,   135,   135,   135,   136,   136,   137,   137,   137,
     137,   137,   137,   138,   138,   139,   139,   139,   139,   139,
     140,   140,   141,   141,   142,   142,   143,   143,   144,   144,
     145,   145,   145,   146,   146,   147,   147,   148,   148
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     7,     2,     1,     1,
       6,     0,     3,     1,     1,     7,     0,     3,     4,     6,
       0,     2,     1,     1,     7,     0,     3,     0,     2,     6,
       2,     0,     3,     7,     5,     4,     6,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     2,     1,     1,
       1,     1,     1,     6,     0,     1,     0,     1,     2,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     6,     0,
       1,     0,     2,     0,     3,     2,     4,     3,     1,     1,
       0,     1,     1,     1,     3,     0,     4,     0,     3,     4,
       4,     4,     2,     0,     1,     0,     4,     4,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     6,     1,     2,     4,     0,     3,     2,     2,     2,
       5,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     2,     1,     1,     2,     0,     1,
       0,     3,     2,     0,     3,     0,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, webidl_ast, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if WEBIDL_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined WEBIDL_LTYPE_IS_TRIVIAL && WEBIDL_LTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, webidl_ast); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct webidl_node **webidl_ast)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (webidl_ast);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct webidl_node **webidl_ast)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, webidl_ast);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, struct webidl_node **webidl_ast)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , webidl_ast);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, webidl_ast); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !WEBIDL_DEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !WEBIDL_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, struct webidl_node **webidl_ast)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (webidl_ast);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct webidl_node **webidl_ast)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined WEBIDL_LTYPE_IS_TRIVIAL && WEBIDL_LTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 195 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.node) = NULL;
        }
#line 1774 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 3:
#line 200 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            webidl_node_add((yyvsp[0].node), (yyvsp[-1].node));
            (yyval.node) = *webidl_ast = webidl_node_prepend(*webidl_ast, (yyvsp[0].node));
        }
#line 1783 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 4:
#line 206 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            fprintf(stderr, "%d: %s\n", yylloc.first_line, errtxt);
            free(errtxt);
            YYABORT ;
        }
#line 1793 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 234 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = (yyvsp[0].node);
        }
#line 1801 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 16:
#line 251 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* extend interface with additional members */
            struct webidl_node *interface_node;
            struct webidl_node *members = NULL;

            if ((yyvsp[-4].text) != NULL) {
                members = webidl_node_new(WEBIDL_NODE_TYPE_INTERFACE_INHERITANCE, members, (yyvsp[-4].text));
            }

            members = webidl_node_new(WEBIDL_NODE_TYPE_LIST, members, (yyvsp[-2].node));


            interface_node = webidl_node_find_type_ident(*webidl_ast,
                                                     WEBIDL_NODE_TYPE_INTERFACE,
                                                     (yyvsp[-5].text));

            if (interface_node == NULL) {
                /* no existing interface - create one with ident */
                members = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, members, (yyvsp[-5].text));

                (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_INTERFACE, NULL, members);
            } else {
                /* update the existing interface */

                /* link member node into interfaces_node */
                webidl_node_add(interface_node, members);

                (yyval.node) = NULL; /* updating so no need to add a new node */
            }
        }
#line 1836 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 286 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = (yyvsp[0].node);
        }
#line 1844 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 301 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* extend interface with additional members */
            struct webidl_node *members;
            struct webidl_node *interface_node;

            interface_node = webidl_node_find_type_ident(*webidl_ast,
                                                     WEBIDL_NODE_TYPE_INTERFACE,
                                                     (yyvsp[-4].text));

            members = webidl_node_new(WEBIDL_NODE_TYPE_LIST, NULL, (yyvsp[-2].node));

            if (interface_node == NULL) {
                /* doesnt already exist so create it */

                members = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, members, (yyvsp[-4].text));

                (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_INTERFACE, NULL, members);
            } else {
                /* update the existing interface */

                /* link member node into interfaces_node */
                webidl_node_add(interface_node, members);

                (yyval.node) = NULL; /* updating so no need to add a new node */
            }
        }
#line 1875 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 332 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.node) = NULL;
        }
#line 1883 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 344 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *member_node;
            struct webidl_node *ident_node;
            struct webidl_node *list_node;

            ident_node = webidl_node_find_type(webidl_node_getnode((yyvsp[0].node)),
                                               NULL,
                                               WEBIDL_NODE_TYPE_IDENT);

            list_node = webidl_node_find_type(webidl_node_getnode((yyvsp[0].node)),
                                              NULL,
                                              WEBIDL_NODE_TYPE_LIST);

            if (ident_node == NULL) {
                /* something with no ident - possibly constructors? */
                /* @todo understand this abtter */

                (yyval.node) = webidl_node_prepend((yyvsp[-2].node), (yyvsp[0].node));

            } else if (list_node == NULL) {
                /* member with no argument list, usually an attribute, cannot
                 * be polymorphic
                 */

                /* add extended attributes to parameter list */
                webidl_node_add((yyvsp[0].node), (yyvsp[-1].node));

                (yyval.node) = webidl_node_prepend((yyvsp[-2].node), (yyvsp[0].node));

            } else {
                /* add extended attributes to parameter list */
                webidl_node_add(list_node, (yyvsp[-1].node));

                /* has an arguemnt list so can be polymorphic */
                member_node = webidl_node_find_type_ident((yyvsp[-2].node),
                                             webidl_node_gettype((yyvsp[0].node)),
                                             webidl_node_gettext(ident_node));
                if (member_node == NULL) {
                    /* not a member with that ident already present */
                    (yyval.node) = webidl_node_prepend((yyvsp[-2].node), (yyvsp[0].node));
                } else {
                    webidl_node_add(member_node, list_node);
                    (yyval.node) = (yyvsp[-2].node); /* updated existing node do not add new one */
                }
            }
        }
#line 1934 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 402 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 1942 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 422 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 1950 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 444 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 1958 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 459 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.text) = NULL;
        }
#line 1966 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 464 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.text) = (yyvsp[0].text);
        }
#line 1974 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 472 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 1982 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 492 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 1990 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 500 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 1998 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 508 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* extend interface with implements members */
            struct webidl_node *implements;
            struct webidl_node *interface_node;


            interface_node = webidl_node_find_type_ident(*webidl_ast,
                                                     WEBIDL_NODE_TYPE_INTERFACE,
                                                     (yyvsp[-3].text));

            implements = webidl_node_new(WEBIDL_NODE_TYPE_INTERFACE_IMPLEMENTS, NULL, (yyvsp[-1].text));

            if (interface_node == NULL) {
                /* interface doesnt already exist so create it */

                implements = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, implements, (yyvsp[-3].text));

                (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_INTERFACE, NULL, implements);
            } else {
                /* update the existing interface */

                /* link implements node into interfaces_node */
                webidl_node_add(interface_node, implements);

                (yyval.node) = NULL; /* updating so no need to add a new node */
            }
        }
#line 2030 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 540 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *constant;

            constant = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, NULL, (yyvsp[-3].text));

            /* add constant type */
            constant = webidl_node_prepend(constant, (yyvsp[-4].node));

            /* add constant value */
            constant = webidl_node_prepend(constant, (yyvsp[-1].node));

            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_CONST, NULL, constant);
        }
#line 2048 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 49:
#line 562 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_INT, NULL, (void *)(yyvsp[0].value));
        }
#line 2056 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 567 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_NULL, NULL, NULL);
        }
#line 2064 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 575 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_BOOL, NULL, (void *)true);
        }
#line 2072 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 580 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_BOOL, NULL, (void *)false);
        }
#line 2080 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 588 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          float *value;
          value = malloc(sizeof(float));
          *value = strtof((yyvsp[0].text), NULL);
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_FLOAT, NULL, value);
        }
#line 2091 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 596 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          float *value;
          value = malloc(sizeof(float));
          *value = -INFINITY;
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_FLOAT, NULL, value);
        }
#line 2102 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 604 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          float *value;
          value = malloc(sizeof(float));
          *value = INFINITY;
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_FLOAT, NULL, value);
        }
#line 2113 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 612 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          float *value;
          value = malloc(sizeof(float));
          *value = NAN;
          (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LITERAL_FLOAT, NULL, value);
        }
#line 2124 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 623 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = (yyvsp[0].node);
        }
#line 2132 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 637 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* @todo deal with stringifier */
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_OPERATION, NULL, (yyvsp[0].node));
        }
#line 2141 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 643 "src/webidl-parser.y" /* yacc.c:1646  */
    {
          (yyval.node)=NULL;
        }
#line 2149 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 651 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *attribute;

            attribute = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, NULL, (yyvsp[-1].text));

            /* add attributes type */
            attribute = webidl_node_prepend(attribute, (yyvsp[-2].node));

            /* deal with readonly modifier */
            if ((yyvsp[-4].isit)) {
                attribute = webidl_node_new(WEBIDL_NODE_TYPE_MODIFIER, attribute, (void *)WEBIDL_TYPE_READONLY);
            }

            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_ATTRIBUTE, NULL, attribute);

        }
#line 2170 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 64:
#line 672 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.isit) = false;
        }
#line 2178 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 677 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.isit) = true;
        }
#line 2186 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 685 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.isit) = false;
        }
#line 2194 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 690 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.isit) = true;
        }
#line 2202 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 698 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* @todo fix qualifiers */
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_OPERATION, NULL, (yyvsp[0].node));
        }
#line 2211 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 734 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *arglist;

            /* put return type in argument list */
            arglist = webidl_node_prepend((yyvsp[-2].node), (yyvsp[-5].node));

            /* argument list */
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_LIST, NULL, arglist);

            (yyval.node) = webidl_node_prepend((yyval.node), (yyvsp[-4].node)); /* identifier */
        }
#line 2227 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 750 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2235 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 755 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, NULL, (yyvsp[0].text));
        }
#line 2243 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 766 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2251 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 771 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_append((yyvsp[0].node), (yyvsp[-1].node));
        }
#line 2259 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 779 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2267 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 784 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_append((yyvsp[0].node), (yyvsp[-1].node));
        }
#line 2275 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 793 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = (yyvsp[0].node);
        }
#line 2283 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 801 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *argument;
            argument = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, NULL, (yyvsp[-1].text));
            argument = webidl_node_prepend(argument, (yyvsp[-2].node)); /* add type node */
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_OPTIONAL_ARGUMENT, NULL, argument);
        }
#line 2294 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 809 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *argument;
            argument = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, NULL, (yyvsp[0].text));
            argument = webidl_node_prepend(argument, (yyvsp[-1].node)); /* ellipsis node */
            argument = webidl_node_prepend(argument, (yyvsp[-2].node)); /* add type node */
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_ARGUMENT, NULL, argument);
        }
#line 2306 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 828 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2314 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 833 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_ELLIPSIS, NULL, NULL);
        }
#line 2322 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 853 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2330 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 858 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE, (yyvsp[-1].node), (yyvsp[-2].node));
        }
#line 2338 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 97:
#line 866 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2346 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 98:
#line 871 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE, (yyvsp[0].node), (yyvsp[-1].node));
        }
#line 2354 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 99:
#line 881 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE, (yyvsp[0].node), (yyvsp[-2].node));
        }
#line 2362 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 100:
#line 886 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* @todo should be a WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE_SQUARE */
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE, (yyvsp[0].node), (yyvsp[-2].node));
        }
#line 2371 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 101:
#line 892 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* @todo should be a WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE_CURLY */
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE, (yyvsp[0].node), (yyvsp[-2].node));
        }
#line 2380 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 898 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_append((yyvsp[0].node),
                             webidl_node_new(WEBIDL_NODE_TYPE_IDENT, NULL, (yyvsp[-1].text)));
        }
#line 2389 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 103:
#line 907 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2397 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 912 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = (yyvsp[0].node);
        }
#line 2405 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 105:
#line 920 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2413 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 106:
#line 925 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_prepend(
                     webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE,
                                     NULL,
                                     (yyvsp[-2].node)),
                     (yyvsp[0].node));
        }
#line 2425 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 934 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* @todo should be a WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE_SQUARE */
            (yyval.node) = webidl_node_prepend(
                     webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE,
                                     NULL,
                                     (yyvsp[-2].node)),
                     (yyvsp[0].node));
        }
#line 2438 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 108:
#line 944 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* @todo should be a WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE_CURLY */
            (yyval.node) = webidl_node_prepend(
                     webidl_node_new(WEBIDL_NODE_TYPE_EXTENDED_ATTRIBUTE,
                                     NULL,
                                     (yyvsp[-2].node)),
                     (yyvsp[0].node));
        }
#line 2451 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 109:
#line 954 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_append((yyvsp[0].node),
                             webidl_node_new(WEBIDL_NODE_TYPE_IDENT, NULL, (yyvsp[-1].text)));
        }
#line 2460 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 963 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* @todo loosing base info here might break the attribute */
            (yyval.text) = calloc(1, 32);
            snprintf((yyval.text), 32, "%ld", (yyvsp[0].value));
        }
#line 2470 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 970 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = (yyvsp[0].text);
        }
#line 2478 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 975 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = (yyvsp[0].text);
        }
#line 2486 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 980 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = (yyvsp[0].text);
        }
#line 2494 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 985 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = (yyvsp[0].text);
        }
#line 2502 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 990 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("-");
        }
#line 2510 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 995 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup(".");
        }
#line 2518 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1000 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("...");
        }
#line 2526 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1005 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup(":");
        }
#line 2534 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1010 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup(";");
        }
#line 2542 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1015 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("<");
        }
#line 2550 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1020 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("=");
        }
#line 2558 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1025 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup(">");
        }
#line 2566 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1030 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("?");
        }
#line 2574 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1035 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("Date");
        }
#line 2582 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1040 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("DOMString");
        }
#line 2590 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1045 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("Infinity");
        }
#line 2598 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1050 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("NaN");
        }
#line 2606 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1055 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("any");
        }
#line 2614 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1060 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("boolean");
        }
#line 2622 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1065 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("byte");
        }
#line 2630 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1070 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("double");
        }
#line 2638 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1075 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("false");
        }
#line 2646 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1080 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("float");
        }
#line 2654 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1085 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("long");
        }
#line 2662 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1090 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("null");
        }
#line 2670 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1095 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("object");
        }
#line 2678 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1100 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("octet");
        }
#line 2686 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1105 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("or");
        }
#line 2694 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1110 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("optional");
        }
#line 2702 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1115 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("sequence");
        }
#line 2710 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1120 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("short");
        }
#line 2718 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1125 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("true");
        }
#line 2726 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1130 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("unsigned");
        }
#line 2734 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1135 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("void");
        }
#line 2742 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1140 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = (yyvsp[0].text);
        }
#line 2750 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1148 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("attribute");
        }
#line 2758 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1153 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("callback");
        }
#line 2766 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1158 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("const");
        }
#line 2774 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1163 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("creator");
        }
#line 2782 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1168 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("deleter");
        }
#line 2790 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1173 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("dictionary");
        }
#line 2798 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1178 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("enum");
        }
#line 2806 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1183 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("exception");
        }
#line 2814 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1188 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("getter");
        }
#line 2822 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1193 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("implements");
        }
#line 2830 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1198 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("inherit");
        }
#line 2838 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1203 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("interface");
        }
#line 2846 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1208 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("legacycaller");
        }
#line 2854 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1213 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("partial");
        }
#line 2862 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1218 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("setter");
        }
#line 2870 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1223 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("static");
        }
#line 2878 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1228 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("stringifier");
        }
#line 2886 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1233 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("typedef");
        }
#line 2894 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1238 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup("unrestricted");
        }
#line 2902 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1246 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = (yyvsp[0].text);
        }
#line 2910 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1251 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.text) = strdup(",");
        }
#line 2918 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1259 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE, NULL, (yyvsp[0].node));
        }
#line 2926 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1264 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            /* todo handle suffix */
            (yyval.node) = (yyvsp[-1].node);
        }
#line 2935 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1275 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL; /* todo implement */
        }
#line 2943 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1283 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 2951 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1307 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_prepend((yyvsp[-1].node), (yyvsp[0].node));
        }
#line 2959 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1312 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, (yyvsp[0].node), (void *)WEBIDL_TYPE_STRING);
        }
#line 2967 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1317 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *type;
            type = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, (yyvsp[0].node), (void *)WEBIDL_TYPE_USER);
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, type, (yyvsp[-1].text));
        }
#line 2977 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1324 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, (yyvsp[-2].node), (void *)WEBIDL_TYPE_SEQUENCE);
        }
#line 2985 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1329 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, (yyvsp[0].node), (void *)WEBIDL_TYPE_OBJECT);
        }
#line 2993 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1334 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, (yyvsp[0].node), (void *)WEBIDL_TYPE_DATE);
        }
#line 3001 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1342 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE, NULL, (yyvsp[-1].node));
        }
#line 3009 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1347 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *type;
            type = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_USER);
            type = webidl_node_new(WEBIDL_NODE_TYPE_IDENT, type, (yyvsp[-1].text));
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE, NULL, type);
        }
#line 3020 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1363 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_BOOL);
        }
#line 3028 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1368 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_BYTE);
        }
#line 3036 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1373 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_OCTET);
        }
#line 3044 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1381 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_MODIFIER,
                                 (yyvsp[0].node),
                                 (void *)WEBIDL_TYPE_MODIFIER_UNRESTRICTED);
        }
#line 3054 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1393 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_FLOAT);
        }
#line 3062 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1398 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_DOUBLE);
        }
#line 3070 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1406 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_MODIFIER,
                                 (yyvsp[0].node),
                                 (void *)WEBIDL_TYPE_MODIFIER_UNSIGNED);
        }
#line 3080 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1418 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_SHORT);
        }
#line 3088 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1423 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            if ((yyvsp[0].isit)) {
                (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_LONGLONG);
            } else {
                (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_LONG);
            }
        }
#line 3100 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1435 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.isit) = false;
        }
#line 3108 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1440 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.isit) = true;
        }
#line 3116 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1448 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 3124 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1453 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_ARRAY, (yyvsp[0].node), NULL);
        }
#line 3132 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1458 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_NULLABLE, (yyvsp[0].node), NULL);
        }
#line 3140 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1466 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = NULL;
        }
#line 3148 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1471 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_ARRAY, (yyvsp[0].node), NULL);
        }
#line 3156 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1488 "src/webidl-parser.y" /* yacc.c:1646  */
    {
            struct webidl_node *type;
            type = webidl_node_new(WEBIDL_NODE_TYPE_TYPE_BASE, NULL, (void *)WEBIDL_TYPE_VOID);
            (yyval.node) = webidl_node_new(WEBIDL_NODE_TYPE_TYPE, NULL, type);
        }
#line 3166 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
    break;


#line 3170 "build-Linux-Linux-release-binary/webidl-parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, webidl_ast, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, webidl_ast, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, webidl_ast);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, webidl_ast);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, webidl_ast, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, webidl_ast);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, webidl_ast);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1496 "src/webidl-parser.y" /* yacc.c:1906  */

